/* eslint-disable */
if(process.env.CONTENT_TYPE === ContentTypes.EDETAILER) {
  require("core-js/stable");
  require("regenerator-runtime/runtime");
  const { getStoryboard, getChapterSlides } = require('@ewizardjs/structure-api');
  // require('@/App.vue'); FIX: EWP-34705;
  if (window.__publicPath) {
    const templatesDir = /\/$/.test(window.__publicPath) ? 'templates/' : '/templates/';
    __webpack_public_path__ = window.__publicPath + templatesDir;
  } else {
    __webpack_public_path__ = './templates/';
  }

  const structure = require('@/structure.json');
  const { slides } = structure;
  const usedSlides = getUsedSlides(structure);

  const templates = usedSlides.map(slide => {
    const component = require(`@/slides/${slide}/index.vue`).default;
    const thumbnail = require(`@/slides/${slide}/media/images/thumb.jpg`);

    component.templateName = slides[slide].name;
    component.templateThumbnail = thumbnail;

    return component;
  });

  function getUsedSlides(structure) {
    const storyboardChapters = getStoryboard(structure, { visible: true, hidden: true }).map(getId);
    return storyboardChapters.reduce((result, chapterId) => {
        const chapterSlides = getChapterSlides(structure, chapterId, { visible: true, hidden: true }).map(getId);
        return [...result, ...chapterSlides];
      }, []);
  }

  function getId(item) {
    return item.id;
  }

  module.exports = { templates, structure };
} else if (process.env.CONTENT_TYPE === ContentTypes.BANNER) {
  require("core-js/stable");
  require("regenerator-runtime/runtime");
  if (window.__publicPath) {
    const templatesDir = /\/$/.test(window.__publicPath) ? 'templates/' : '/templates/';
    __webpack_public_path__ = window.__publicPath + templatesDir;
  } else {
    __webpack_public_path__ = './templates/';
  }

  const structure = require('@/templates.json');

  const usedBanners = /#marker-component-banners/;

  const templates = [];

  for (const [key, value] of Object.entries(usedBanners)) {
    const { name, requiredComponent, templateThumbnail } = value;
    const component = requiredComponent.default;
    component.templateName = name;
    component.componentId = key;
    component.templateThumbnail = templateThumbnail ? templateThumbnail : null;

    templates.push(component);
  }

  module.exports = { templates, structure };
}
