"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filename = void 0;
const builder_utils_1 = require("@ewizardjs/builder-utils");
const plugins_1 = require("@ewizardjs/builder-utils/plugins");
const systemSettingsApi = __importStar(require("@ewizardjs/system-settings"));
const path_1 = require("path");
const ramda_1 = require("ramda");
const webpack_1 = require("webpack");
const webpack_merge_1 = require("webpack-merge");
const get_plugins_loaders_1 = __importDefault(require("../get-plugins-loaders"));
const get_style_loaders_1 = __importDefault(require("../get-style-loaders"));
const get_template_loaders_1 = __importDefault(require("../get-template-loaders"));
const content_type_loader_1 = require("../loaders/content-type-loader");
const plugins_2 = require("../plugins");
exports.filename = 'build/dev/module.js';
async function default_1(options) {
    const { presentationPath } = options;
    const { componentsProps, pages, contentEntities, systemSettings: systemSettingsArgs, } = await (0, builder_utils_1.getArguments)((0, path_1.resolve)(__dirname, '..', 'strategies'), options);
    const absoluteBaseDir = (0, path_1.resolve)(process.cwd(), presentationPath);
    const systemSettings = await systemSettingsApi.get(absoluteBaseDir);
    const nodeModulesPaths = require.resolve.paths('') || [];
    const pluginsOptions = (0, ramda_1.pathOr)({}, ['plugins'], systemSettings);
    const pluginsLoaders = (0, get_plugins_loaders_1.default)(pluginsOptions, options);
    const webpackDevLoaders = await (0, builder_utils_1.getWebpackDevRules)(presentationPath);
    const devConfig = {
        mode: 'production',
        performance: {
            hints: false,
        },
        optimization: {
            noEmitOnErrors: false,
        },
        context: absoluteBaseDir,
        entry: [require.resolve('../../assets/entry-module')],
        output: {
            filename: exports.filename,
            path: absoluteBaseDir,
        },
        resolveLoader: {
            modules: [(0, path_1.join)(__dirname, '../loaders'), ...nodeModulesPaths],
        },
        resolve: {
            extensions: ['.webpack.js', '.web.js', '.ts', '.tsx', '.js'],
            alias: {
                '@': presentationPath,
            },
            modules: ['node_modules', (0, path_1.resolve)(presentationPath, 'node_modules')],
        },
        module: {
            rules: [
                ...(await (0, get_template_loaders_1.default)(systemSettingsArgs, presentationPath, componentsProps, pages, contentEntities)),
                ...(await (0, get_style_loaders_1.default)(systemSettings, presentationPath)),
                {
                    test: (0, path_1.resolve)(absoluteBaseDir, 'index.vue'),
                    use: [
                        {
                            loader: require.resolve('../loaders/config-loader'),
                        },
                    ],
                },
                ...pluginsLoaders,
                ...(0, content_type_loader_1.getContentTypeLoader)({
                    include: (0, path_1.resolve)(absoluteBaseDir),
                    exclude: /node_modules/,
                }),
            ],
        },
        plugins: [
            (0, plugins_2.statsLog)(),
            (0, plugins_1.vueLoader)(),
            new webpack_1.DefinePlugin({
                EWIZARDJS: Object.assign({ SYSTEM_SETTINGS: JSON.stringify(systemSettings) }, (0, builder_utils_1.getExpandedSystemSettings)(presentationPath, systemSettings)),
                'process.env': {
                    NODE_ENV: JSON.stringify('production'),
                },
            }),
        ],
    };
    return (0, webpack_merge_1.merge)(devConfig, webpackDevLoaders);
}
exports.default = default_1;
//# sourceMappingURL=webpack.config.js.map