"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ramda_1 = require("ramda");
const enums_1 = require("./enums");
function getPluginsLoaders(plugins = {}, options = {}) {
    const loaders = getLoaders(options);
    return (0, ramda_1.compose)(ramda_1.values, (0, ramda_1.filter)(Boolean), (0, ramda_1.evolve)(loaders), (0, ramda_1.pick)((0, ramda_1.keys)(loaders)))(plugins);
}
exports.default = getPluginsLoaders;
function getLoaders(options) {
    return {
        eslint: createLintLoader(options.eslint, options.target),
    };
}
function createLintLoader(options = {}, target) {
    return createLoader((0, ramda_1.curryN)(2, lintLoader)(options), () => target !== enums_1.Target.Ewizard);
}
function createLoader(creator, pred = ramda_1.T) {
    return (0, ramda_1.ifElse)((0, ramda_1.allPass)([ramda_1.identity, pred]), creator, ramda_1.F);
}
function lintLoader(options = {}) {
    return {
        options,
        test: /\.(js|vue)$/,
        exclude: /node_modules/,
        enforce: 'pre',
        loader: 'eslint-loader',
    };
}
//# sourceMappingURL=get-plugins-loaders.js.map