"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
async function default_1(source) {
    const resourcePath = (0, utils_1.toUnixPath)(this.resourcePath);
    const styles = await getEditorStyles(resourcePath);
    return styles ? source.replace('export default component.exports', `;component.options.styles = '${styles}';
    export default component.exports;`) : source;
}
exports.default = default_1;
async function getEditorStyles(filePath) {
    const vueFileContent = await (0, utils_1.getNormalizedVueFileContent)(filePath);
    const template = /<style (scoped)?\s?editor>([\s\S]*?)<\/style>/.exec(vueFileContent);
    return template && template[2];
}
//# sourceMappingURL=editor-style-loader.js.map