"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const loader_utils_1 = __importDefault(require("loader-utils"));
const semver_1 = require("semver");
const utils_1 = require("../utils");
async function default_1(source) {
    const { presentationPath } = loader_utils_1.default.getOptions(this);
    try {
        const ewizardjsVersion = await (0, utils_1.getEwizardjsVersion)(presentationPath);
        if ((0, semver_1.major)(ewizardjsVersion) >= 5) {
            const [requireApp] = getMarkedCode(source);
            return source.replace(requireApp, '');
        }
    }
    catch (e) {
        return source;
    }
    return source;
}
exports.default = default_1;
function getMarkedCode(source) {
    const markerRE = /\/\/\smarker:start require-app.*?\/\/\smarker:end require-app/s;
    return source.match(markerRE);
}
//# sourceMappingURL=entry-common-loader.js.map