"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComponentsBuilder = void 0;
const devBuilder_1 = require("./devBuilder");
const webpack_config_1 = __importDefault(require("../components/webpack.config"));
const webpack_1 = __importDefault(require("webpack"));
class ComponentsBuilder extends devBuilder_1.DevBuilder {
    getComponentsConfig(options) {
        return (0, webpack_config_1.default)(Object.assign(Object.assign({}, this.options), options));
    }
    async getCompiler(options) {
        const config = await Promise.all([
            this.getComponentsConfig(options),
            ...await this.getConfigWithComponentsListLibrary(options),
        ]);
        return (0, webpack_1.default)(config);
    }
}
exports.ComponentsBuilder = ComponentsBuilder;
//# sourceMappingURL=componentsBuilder.js.map