"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LayoutsBuilder = void 0;
const devBuilder_1 = require("./devBuilder");
const webpack_1 = __importDefault(require("webpack"));
const clone_1 = __importDefault(require("clone"));
const utils_1 = require("../utils");
const PLUGINS_TO_REMOVE = ['WebpackBarPlugin'];
class LayoutsBuilder extends devBuilder_1.DevBuilder {
    async getCompiler(options) {
        const layoutConfig = await this.getLayoutConfig(options);
        const componentsConfig = getComponentsBaseConfig(layoutConfig);
        const mergedConfig = await this.getConfigWithComponentsListLibrary(options, componentsConfig);
        return (0, webpack_1.default)([layoutConfig, ...mergedConfig]);
    }
}
exports.LayoutsBuilder = LayoutsBuilder;
function getComponentsBaseConfig(config) {
    const baseConfig = (0, clone_1.default)(config);
    baseConfig.plugins = (0, utils_1.removePlugins)(baseConfig.plugins, PLUGINS_TO_REMOVE);
    return baseConfig;
}
//# sourceMappingURL=layoutsBuilder.js.map