"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResetStatePlugin = void 0;
const path_1 = require("path");
const fs_extra_1 = require("fs-extra");
class ResetStatePlugin {
    constructor(contentPath) {
        this.contentPath = contentPath;
    }
    apply(compiler) {
        compiler.hooks.afterEmit.tapPromise('ResetStatePlugin', async () => {
            const stateFilePath = (0, path_1.join)(this.contentPath, 'build', 'dev', 'state.js');
            return (0, fs_extra_1.writeFile)(stateFilePath, 'window.__contentState = {};', { encoding: 'utf8' });
        });
    }
}
exports.ResetStatePlugin = ResetStatePlugin;
//# sourceMappingURL=ResetStatePlugin.js.map