import { LayoutOptions } from '@ewizardjs/alias-resolver';
import { ComponentsFileProps } from '@ewizardjs/builder-utils';
export interface ManifestComponent {
    id: string;
    path?: string;
    icon?: string | Record<string, string>;
    iconsPath?: string;
}
export interface Manifest {
    components: ManifestComponent[];
}
export interface ManifestCompoundComponent {
    id: string;
    path?: string;
    icon?: string | Record<string, string>;
}
export interface ManifestThemesComponent {
    blocks: Array<string | ManifestCompoundComponent & {
        name?: string;
    }>;
    defaultBlocks: Array<string | Omit<ManifestCompoundComponent, 'path' | 'icon'> & {
        purpose?: string[];
    }>;
}
export interface CompoundManifest {
    components: ManifestCompoundComponent[];
}
export interface BlocksThemesManifest {
    themes: {
        [themeName: string]: ManifestThemesComponent;
    };
}
export interface Options {
    type: string;
    blocksPath: string;
    presentationPath: string;
    blockManifestPath: string;
    componentManifestPath: string;
    componentsProps: ComponentsFileProps;
    blocksThemesPath: string;
    componentsThemesPath: string;
    masterTemplatePath?: string;
    currentTheme?: string;
    layoutOptions: LayoutOptions;
}
